program CountMem;

(**************************************************************************
This simple program fills memory with a four byte pattern, then shells to
the specified program.  When the program returns, it checks memory for the
largest block still containing that pattern, and computes the number of
bytes not used by the application.  This does not give a perfect indication
of memory requirements (for example, some programs allocate more or less
memory depending on how much is left), but it is at least a start.

COUNTMEM  <program>  {<parameter>...}
<program> must be the complete program name, e.g., test.exe

This program is in the public domain.

Joe Ahlgren   BBS  703-241-7980
94/04/10
**************************************************************************)

{$M 2048,0,0}
{$N-}
  uses dos;
  const
    MemCheckBytes: longint = $79656f6a;
  type
    alongint = array [0..3] of longint;
    MCBtype = record
      MCBstat: byte;
      MCBowner: word;
      MCBlength: word;
      end;
  var
    P: ^alongint;
    MCB: ^MCBtype;
    j,k,n: integer;
    s,s1,s2: word;
    nc,nm: longint;
  begin
    MCB:=ptr(PrefixSeg-1,0);
    s1:=MCB^.MCBlength+PrefixSeg;
    s2:=$9ffe;
    for s:=s1+$100 to s2 do
      begin
      p:=ptr(s,0);
      for j:=0 to 3 do
        p^[j]:=MemCheckBytes;
      end;
    exec(paramstr(1),paramstr(2));
    if DosError = 0 then
      begin
      nc:=0;
      nm:=0;
      for s:=s1+$100 to s2 do
        begin
        p:=ptr(s,0);
        for j:=0 to 3 do
          if p^[j]=MemCheckBytes then
            inc(nc)
           else
            begin
            if nc > nm then nm:=nc;
            nc:=0;
            end;
        end;
      if nc > nm then nm:=nc;
      WriteLn('loaded at ',longint(s1)*16,', ',nm*4,' bytes not used, ',
           (longint(s2)-longint(s1))*16-nm*4,' bytes used');
      end
     else
      WriteLn('DOS error');
end.